// IirCoeffView.cpp : CIirCoeffView NX̓̒`s܂B
// by Toshio Iwata at digitalfilter.com 2004/09/16

#include "stdafx.h"
#include "IirCoeff.h"

#include "IirCoeffDoc.h"
#include "IirCoeffView.h"
#include "DlgLpf.h"
#include "DlgHpf.h"
#include "DlgBpf.h"
#include "DlgBrf.h"
#include "DlgWarnFs.h"
#include "DlgWarnFc.h"

#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CIirCoeffView

IMPLEMENT_DYNCREATE(CIirCoeffView, CView)

BEGIN_MESSAGE_MAP(CIirCoeffView, CView)
	//{{AFX_MSG_MAP(CIirCoeffView)
	ON_COMMAND(ID_MENU_SV, OnMenuSv)
	ON_COMMAND(ID_MENU_LPF, OnMenuLpf)
	ON_COMMAND(ID_MENU_BPF, OnMenuBpf)
	ON_COMMAND(ID_MENU_HPF, OnMenuHpf)
	ON_COMMAND(ID_MENU_BRF, OnMenuBrf)
	//}}AFX_MSG_MAP
	// WR}h
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CIirCoeffView NX̍\z/

CIirCoeffView::CIirCoeffView()
{
	// TODO: ̏ꏊɍ\zp̃R[hǉĂB
	int i;
	for (i = 0; i < 8; i++) { 
		p_a0[i] = 1.0; 
		p_a1[i] = 0.0; 
		p_a2[i] = 0.0; 
		p_b1[i] = 0.0; 
		p_b2[i] = 0.0; 
	}
	Pi = 3.14159;
	gain_range = 100.0;
	Fsamp = 22050;
	freq_range = Fsamp/2.0;
	Order = 2;
	FilType = 0;
	FC1 = 2000;
	FC2 = 5000;
	design_clicked = FALSE;
}

CIirCoeffView::~CIirCoeffView()
{
}

BOOL CIirCoeffView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ̈ʒu CREATESTRUCT cs C Window NX܂̓X^C
	//  CĂB

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CIirCoeffView NX̕`

void CIirCoeffView::OnDraw(CDC* pDC)
{
	CIirCoeffDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: ̏ꏊɃlCeBu f[^p̕`R[hǉ܂B
	if(design_clicked) {
		IirDesign(FilType, Order, Fsamp, FC1, FC2);
		IirFresCal(Gain, Theta);
		FresDraw(pDC, 100, 60, Gain, Theta);
	} else {
		pDC->TextOut( 50, 50, "IirCoeff.exe");
		pDC->TextOut( 50, 80, "IIRtB^̌WZo܂B");
		pDC->TextOut( 50, 110, "u݌vvIĂB");
		pDC->TextOut( 50, 140, "by DIGITALFILTER.COM");
	}
}

/////////////////////////////////////////////////////////////////////////////
// CIirCoeffView NẌ

BOOL CIirCoeffView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// ftHg̈
	return DoPreparePrinting(pInfo);
}

void CIirCoeffView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: O̓ʂȏǉĂB
}

void CIirCoeffView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: ̌㏈ǉĂB
}

/////////////////////////////////////////////////////////////////////////////
// CIirCoeffView NX̐ff

#ifdef _DEBUG
void CIirCoeffView::AssertValid() const
{
	CView::AssertValid();
}

void CIirCoeffView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CIirCoeffDoc* CIirCoeffView::GetDocument() // fobO o[W̓CCłB
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CIirCoeffDoc)));
	return (CIirCoeffDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CIirCoeffView NX̃bZ[W nh

void CIirCoeffView::IirDesign(short FilterType, short FilterOrder, 
							  double Fs, double Fc1, double Fc2)
{
	p_Fsamp = Fs;

	p_fc = Fc1; 
	p_fc2 = Fc2;
	p_AC = 3.0;
	FilType = FilterType;
	OrderN = FilterOrder;

	BasicFilCal();
	PreWarp();
	FreqTrans();
	SZTrans();
}

//////////////////////////////////////////////
// Basic Analog LPF
void CIirCoeffView::BasicFilCal() // Butterworth
{
	int i;
	double d0, bi, ai;
	double eps;

	eps = sqrt(pow(10.0, p_AC/10.0) - 1);
	d0 = pow(eps, (-1.0/OrderN));
	bi = d0 * d0;
	i = 1;
	ai = 2.0 * d0 * sin( i * Pi / (2.0 * OrderN) );

	if( OrderN == 1 ) {
		PN2 = 0.0; PN1 = 0.0; PN0 = d0;
		PD2 = 0.0; PD1 = 1.0; PD0 = d0;
	} else {
		PN2 = 0.0; PN1 = 0.0; PN0 = bi; 
		PD2 = 1.0; PD1 = ai; PD0 = bi;
	}
}	

//////////////////////////////////////////////
// Pre Warping
void CIirCoeffView::PreWarp()
{
	double tmp_wc1, tmp_wc2;

	FC1 = (float)p_fc;
	tmp_wc1 = (2.0 * p_Fsamp) * tan(2.0 * Pi * FC1 / (2.0 * p_Fsamp));
	fcp1 = (float)(tmp_wc1 / (2.0 * Pi));

	FC2 = (float)p_fc2;
	tmp_wc2 = (2.0 * p_Fsamp) * tan(2.0 * Pi * FC2 / (2.0 * p_Fsamp));
	fcp2 = (float)(tmp_wc2 / (2.0 * Pi));

}

//////////////////////////////////////////////
// Frequency Transformation
void CIirCoeffView::FreqTrans()
{
	double wc1, wc2;
	double wb, w0;
	double xx, dd, ww, zz, uu, vv;

	wc1 = 2.0 * Pi * fcp1;
	wc2 = 2.0 * Pi * fcp2;
	wb = wc2 - wc1;
	w0 = sqrt(wc1 * wc2);

	if( FilType == 0 ) { // LPF
		if( OrderN == 1 ) {
			SH  = PD0 * wc1;
			SN2 = 0.0; SN1 = 0.0; SN0 = 1.0;
			SD2 = 0.0; SD1 = 1.0; SD0 = PD0 * wc1;
		} else {
			SH  = PD0 * wc1 * wc1;
			SN2 = 0.0; SN1 = 0.0; SN0 = 1.0;
			SD2 = 1.0; SD1 = PD1 * wc1; SD0 = PD0 * wc1 * wc1;
		}
	} else if( FilType == 1 ) { // HPF
		if( OrderN == 1 ) {
			SH  = 1.0;
			SN2 = 0.0; SN1 = 1.0; SN0 = 0.0;
			SD2 = 0.0; SD1 = 1.0; SD0 = wc1 / PD0;
		} else {
			SH  = 1.0;
			SN2 = 1.0; SN1 = 0.0; SN0 = 0.0;
			SD2 = 1.0; SD1 = PD1 * wc1 / PD0; SD0 = wc1 * wc1 / PD0;
		}
	} else if( FilType == 2 ) { // BPF
		xx = wb / w0;
		dd = PD1 * xx / 2.0;
		ww = xx * sqrt(4.0 * PD0 - PD1 * PD1 ) / 2.0;
		zz = 4.0 - dd * dd + ww * ww;
		uu = sqrt(zz / 2 + sqrt(zz * zz / 4.0 + dd * dd * ww * ww));
		vv = dd * ww / uu;
		if( OrderN == 1 ) {
			SH  = PD0 * wb;
			SN2 = 0.0; SN1 = 1.0; SN0 = 0.0;
			SD2 = 1.0; SD1 = PD0 * wb; SD0 = w0 * w0;
		} else { 
			SH   = sqrt(wb * wb * PD0);
			SN2 = 0.0; SN1 = 1.0; SN0 = 0.0;
			SD2 = 1.0; SD1 = w0 * (dd + vv);
			SD0 = w0 * w0 * ((dd + vv) * (dd + vv) 
				+ (ww + uu) * (ww + uu)) / 4.0;

			TH  = sqrt(wb * wb * PD0);
			TN2 = 0.0; TN1 = 1.0; TN0 = 0.0;
			TD2 = 1.0; TD1 = w0 * (dd - vv);
			TD0 = w0 * w0 * ((dd - vv) * (dd - vv) 
				+ (ww - uu) * (ww - uu)) / 4.0;
		}
	} else if( FilType == 3 ) { // BRF
		xx = wb / w0;
		dd = (PD1/PD0) * xx / 2.0;
		ww = xx * sqrt(4.0 * (1.0/PD0) - (PD1/PD0) * (PD1/PD0) ) / 2.0;
		zz = 4.0 - dd * dd + ww * ww;
		uu = sqrt(zz / 2 + sqrt(zz * zz / 4.0 + dd * dd * ww * ww));
		vv = dd * ww / uu;
		if( OrderN == 1 ) {
			SH  = 1.0;
			SN2 = 1.0; SN1 = 0.0; SN0 = w0 * w0;
			SD2 = 1.0; SD1 = wb / PD0; SD0 = w0 * w0;
		} else {
			SH  = 1.0;
			SN2 = 1.0; SN1 = 0.0; SN0 = w0 * w0;
			SD2 = 1.0; SD1 = w0 * (dd + vv);
			SD0 = w0 * w0 * ((dd + vv) * (dd + vv) 
				+ (ww + uu) * (ww + uu)) / 4.0;
			TH  = 1.0;
			TN2 = 1.0; TN1 = 0.0; TN0 = w0 * w0;
			TD2 = 1.0; TD1 = w0 * (dd - vv);
			TD0 = w0 * w0 * ((dd - vv) * (dd - vv) 
				+ (ww - uu) * (ww - uu)) / 4.0;
		}
	}
}

//////////////////////////////////////////////
// s-z Transformation
void CIirCoeffView::SZTrans()
{
	double alpha, beta, gg;
	int i;
	for (i = 0; i < 8; i++) {
		p_a0[i]=1.0; p_a1[i]=0.0; p_a2[i]=0.0; p_b1[i]=0.0; p_b2[i]=0.0;
	}

	alpha = 2.0 * p_Fsamp;

	if( FilType == 0 || FilType == 1 ) {
		if( OrderN == 1 ) {
			gg = 1.0 / (SD0 + alpha);
			p_a0[0] = (SN1 * alpha + SN0) * SH * gg;
			p_a1[0] = (SN0 - SN1 * alpha) * SH * gg;
			p_a2[0] = 0.0 * SH;
			p_b1[0] = (SD0 - alpha) / (SD0 + alpha);
			p_b2[0] = 0.0;
		} else {
			beta = SN2 * alpha * alpha;
			gg  = 1.0 / (alpha * alpha + SD1 * alpha + SD0);
			p_a0[0] = (beta + SN1 * alpha + SN0) * SH * gg;
			p_a1[0] = 2.0 * (SN0 - beta) * SH * gg;
			p_a2[0] = (beta - SN1 * alpha + SN0) * SH * gg;
			p_b1[0] = 2.0 * gg * (SD0 - alpha * alpha);
			p_b2[0] = gg * (alpha * alpha - SD1 * alpha + SD0);
		}
	} else {
		beta = SN2 * alpha * alpha;
		gg  = 1.0 / (alpha * alpha + SD1 * alpha + SD0);
		p_a0[0] = (beta + SN1 * alpha + SN0) * SH * gg;
		p_a1[0] = 2.0 * (SN0 - beta) * SH * gg;
		p_a2[0] = (beta - SN1 * alpha + SN0) * SH * gg;
		p_b1[0] = 2.0 * gg * (SD0 - alpha * alpha);
		p_b2[0] = gg * (alpha * alpha - SD1 * alpha + SD0);
		if( OrderN == 2 ) {
			beta = TN2 * alpha * alpha;
			gg  = 1.0 / (alpha * alpha + TD1 * alpha + TD0);
			p_a0[1] = (beta + TN1 * alpha + TN0) * TH * gg;
			p_a1[1] = 2.0 * (TN0 - beta) * TH * gg;
			p_a2[1] = (beta - TN1 * alpha + TN0) * TH * gg;
			p_b1[1] = 2.0 * gg * (TD0 - alpha * alpha);
			p_b2[1] = gg * (alpha * alpha - TD1 * alpha + TD0);
		}
	}
}

void CIirCoeffView::SaveCoeff()
{
	FILE *fpo;
	double tmpcoeff;
	int i, filco;

	CFileDialog dlgF(FALSE, NULL, "coeff1.txt");
	if( dlgF.DoModal() == IDOK)	{
		//filenameɑIt@C̃tpX
		filenamesv = dlgF.GetPathName();
		fpo = fopen( filenamesv, "w" );
		//ȍ~t@CɃf[^
		if (fpo != NULL) { 
			if( (FilType == 2 || FilType == 3) && (OrderN == 2) ) {
				filco = 2;
			} else {
				filco = 1;
			}
			for( i = 0; i < filco; i++ ) {
				tmpcoeff = p_a0[i];
				fprintf(fpo, "%12.7f\n", tmpcoeff);
				tmpcoeff = p_a1[i];
				fprintf(fpo, "%12.7f\n", tmpcoeff);
				tmpcoeff = p_a2[i];
				fprintf(fpo, "%12.7f\n", tmpcoeff);
				tmpcoeff = p_b1[i];
				fprintf(fpo, "%12.7f\n", tmpcoeff);
				tmpcoeff = p_b2[i];
				fprintf(fpo, "%12.7f\n", tmpcoeff);
			}
		}
		fclose(fpo);
	} 
	InvalidateRect(NULL, TRUE);	
}

void CIirCoeffView::OnMenuSv() 
{
	SaveCoeff();	
}

void CIirCoeffView::FresDraw(CDC *pDC, int x0, int y0, double *Xg, double *Xt)
{
	double start_fr, end_fr, mid_fr;
	double tmp_xfr[400], tmp_xth[400];
	int	i;
	char freq_char[15];
	char gain_char[15];
	double xstep = 2.0;

	CPen	myPen;
	CPen*	pOldPen;

	for (i = 0; i < 400; i++) tmp_xfr[i] = 0.0;

	pDC->TextOut(x0 - 50, y0 -  28,"Gain [dB]");
	sprintf(gain_char,"%5.1f", gain_range/5.0);
	pDC->TextOut(x0 - 50, y0 -   8, gain_char);

	pDC->TextOut(x0 - 30, y0 +  32,"  0");

	sprintf(gain_char,"-%5.1f", gain_range/2.0);
	pDC->TextOut(x0 - 60, y0 + 132, gain_char);
	sprintf(gain_char,"-%5.1f", gain_range);
	pDC->TextOut(x0 - 60, y0 + 225, gain_char);
	
	pDC->TextOut(x0 + 360 - 10, y0 - 28,"Phase [rad]");
	pDC->TextOut(x0 + 360 + 10, y0 + 52,"  pi ");
	pDC->TextOut(x0 + 360 + 10, y0 + 92," pi/2");
	pDC->TextOut(x0 + 360 + 10, y0 + 132,"   0 ");
	pDC->TextOut(x0 + 360 + 10, y0 + 172,"-pi/2");
	pDC->TextOut(x0 + 360 + 10, y0 + 212," -pi ");

	start_fr = 0.0;
	end_fr = start_fr + freq_range / 1.0;
	mid_fr = start_fr + freq_range / 2.0;

	sprintf(freq_char,"%10.3f", start_fr);
	pDC->TextOut(x0 - 50, y0 + 250, freq_char);
	sprintf(freq_char,"%10.3f", mid_fr);
	pDC->TextOut(x0 - 10 + 150, y0 + 250, freq_char);
	sprintf(freq_char,"%10.3f", end_fr);
	pDC->TextOut(x0 - 10 + 330, y0 + 250, freq_char);
	pDC->TextOut(x0 - 10 + 410, y0 + 250,"[Hz]");

	myPen.CreatePen(PS_DOT, 1, RGB(100,100,100));
	pOldPen = pDC->SelectObject(&myPen);

	for(i = 0; i <= 12; i++) {
		pDC->MoveTo(x0      , y0 + i * 20);
		pDC->LineTo(x0 + 360, y0 + i * 20);
	}

	for(i = 0; i <= 10; i++) {
		pDC->MoveTo(x0 + i * (360 / 10), y0);
		pDC->LineTo(x0 + i * (360 / 10), y0 + 240);
	}

	pDC->SelectObject(pOldPen);
	myPen.DeleteObject();

	myPen.CreatePen(PS_DOT, 1, RGB(50,50,50));
	pOldPen = pDC->SelectObject(&myPen);

	pDC->MoveTo(x0      , y0 + 2 * 20);
	pDC->LineTo(x0 + 360, y0 + 2 * 20);

	pDC->MoveTo(x0 + 5 * (360 / 10), y0);
	pDC->LineTo(x0 + 5 * (360 / 10), y0 + 240);

	pDC->SelectObject(pOldPen);
	myPen.DeleteObject();

	// Frame drawing
	for(i = 0; i <= 12; i = i + 12) {
		pDC->MoveTo(x0      , y0 + i * 20);
		pDC->LineTo(x0 + 360, y0 + i * 20);
	}
	for(i = 0; i <= 10; i = i + 10) {
		pDC->MoveTo(x0 + i * (360 / 10), y0);
		pDC->LineTo(x0 + i * (360 / 10), y0 + 240);
	}

	myPen.CreatePen(PS_SOLID, 1, RGB(0,255,0));
	pOldPen = pDC->SelectObject(&myPen);
	
	for(i = 0; i < 180; i++) {
    	tmp_xth[i] = 25.5 * Xt[i];
	}

	xstep = Fsamp/freq_range;

	for(i = 0; i < 179; i++) {
		if( (i+1)*xstep < 360 ) {
			pDC->MoveTo(x0 + (int)(i*xstep), y0 + 140 - (int)(tmp_xth[i]));
			pDC->LineTo(x0 + (int)((i+1)*xstep), y0 + 140 - (int)(tmp_xth[i + 1]));
		}
	}
	
	pDC->TextOut(x0 + 200, y0 - 40,"Phase");
   	pDC->MoveTo(x0 + 250, y0 - 30);
	pDC->LineTo(x0 + 270, y0 - 30);

	pDC->SelectObject(pOldPen);
	myPen.DeleteObject();

	myPen.CreatePen(PS_SOLID, 1, RGB(255, 0, 0));
	pOldPen = pDC->SelectObject(&myPen);

	double ymax, ymin, yrange;

	ymax = 40.0;
	ymin = -200.0;
	yrange = 2.0 * 100.0 / gain_range;

	for(i = 0; i < 180; i++) {
    	tmp_xfr[i] = yrange * Xg[i];
		if( tmp_xfr[i] < ymin ) tmp_xfr[i] = ymin;
		if( tmp_xfr[i] > ymax ) tmp_xfr[i] = ymax;
	}

	for(i = 0; i < 179; i++) {
		if( (i+1)*xstep < 360 ) {
			pDC->MoveTo(x0 + (int)(i*xstep), y0 + 40 - (int)(tmp_xfr[i]));
			pDC->LineTo(x0 + (int)((i+1)*xstep), y0 + 40 - (int)(tmp_xfr[i + 1]));

		}
	}
	pDC->TextOut(x0 + 100, y0 - 40,"Gain");
   	pDC->MoveTo(x0 + 140, y0 - 30);
	pDC->LineTo(x0 + 160, y0 - 30);

	pDC->SelectObject(pOldPen);
	myPen.DeleteObject();
}

void CIirCoeffView::IirFresCal(double *Xg, double *Xt)
{
	int i;
	double	omega;
	double	AReal;
	double	AImag;
	double	AAbs_2;
	double	BReal;
	double	BImag;
	double	BAbs_2;
	double	HAbs_2;
	double	HzdB;
	double	HThita;

	double pai = 3.1415926;
	int k;

	int int_th;

	for(i = 0; i < 360; i++) {
		Xg[i] = 0.0;
		Xt[i] = 0.0;
		for(k = 0; k < 2; k++) {
			omega = i * pai / 180.0 + 0.001;

			AReal = 0.0; AImag = 0.0;

			AReal =  p_a0[k] + p_a1[k] * cos(1.0 * omega) + p_a2[k] * cos(2.0 * omega);
			AImag = 0.0 - p_a1[k] * sin(1.0 * omega) - p_a2[k] * sin(2.0 * omega);
			AAbs_2 = AReal * AReal + AImag * AImag;

			BReal = 0.0; BImag = 0.0;

			BReal = 1.0 + p_b1[k] * cos(1.0 * omega) + p_b2[k] * cos(2.0 * omega);
			BImag = 0.0 - p_b1[k] * sin(1.0 * omega) - p_b2[k] * sin(2.0 * omega);
			BAbs_2 = BReal * BReal + BImag * BImag;

			HAbs_2 = AAbs_2 / BAbs_2;
			HzdB = 10 * log10(HAbs_2);

			HzdB = HzdB;

			HThita = 
				atan((AImag*BReal - AReal*BImag) / (AReal*BReal + AImag*BImag));
		
			Xg[i] = Xg[i] + HzdB;
			Xt[i] = Xt[i] + HThita;
			if( Xt[i] < -3.15 ) { 
				int_th = (int)(Xt[i] * 100);
				int_th = int_th % 314;
				Xt[i] = ((double)(int_th)) / 314; 
			}
			if( Xt[i] > 3.15 ) { 
				int_th = (int)(Xt[i] * 100);
				int_th = int_th % 314;
				Xt[i] = ((double)(int_th)) / 314; 
			} 
		}
	}
}

void CIirCoeffView::OnMenuLpf() 
{
	CDlgLpf dlg;

	dlg.m_fc1 = FC1;
	dlg.m_order = Order;
	dlg.m_fs = Fsamp;
	if (dlg.DoModal() == IDOK) {
		if( dlg.m_fc1 >= dlg.m_fs/2 ) {
			CDlgWarnFs dlgW;
			if (dlgW.DoModal() == IDOK) {
			}
		} else {
			FC1 = dlg.m_fc1;
			Order = dlg.m_order;
			Fsamp = dlg.m_fs;
			freq_range = Fsamp/2;
			FilType = 0;
			design_clicked = TRUE;
		}
		InvalidateRect(NULL, TRUE);
	}
}

void CIirCoeffView::OnMenuHpf() 
{
	CDlgHpf dlg;

	dlg.m_fc1 = FC1;
	dlg.m_order = Order;
	dlg.m_fs = Fsamp;
	if (dlg.DoModal() == IDOK) {
		if( dlg.m_fc1 >= dlg.m_fs/2 ) {
			CDlgWarnFs dlgW;
			if (dlgW.DoModal() == IDOK) {
			}
		} else {
			FC1 = dlg.m_fc1;
			Order = dlg.m_order;
			Fsamp = dlg.m_fs;
			freq_range = Fsamp/2;
			FilType = 1;
			design_clicked = TRUE;
		}
		InvalidateRect(NULL, TRUE);
	}
}

void CIirCoeffView::OnMenuBpf() 
{
	CDlgBpf dlg;

	dlg.m_fc1 = FC1;
	dlg.m_fc2 = FC2;
	dlg.m_order = Order;
	dlg.m_fs = Fsamp;
	if (dlg.DoModal() == IDOK) {
		if( dlg.m_fc1 >= dlg.m_fs/2 || dlg.m_fc2 >= dlg.m_fs/2 ) {
			CDlgWarnFs dlgW;
			if (dlgW.DoModal() == IDOK) {
			}
		} else if( dlg.m_fc1 >= dlg.m_fc2 ) {
			CDlgWarnFc dlgW;
			if (dlgW.DoModal() == IDOK) {
			}
		} else{
			FC1 = dlg.m_fc1;
			FC2 = dlg.m_fc2;
			Order = dlg.m_order;
			Fsamp = dlg.m_fs;
			freq_range = Fsamp/2;
			FilType = 2;
			design_clicked = TRUE;
		}
		InvalidateRect(NULL, TRUE);
	}
}


void CIirCoeffView::OnMenuBrf() 
{
	CDlgBrf dlg;

	dlg.m_fc1 = FC1;
	dlg.m_fc2 = FC2;
	dlg.m_order = Order;
	dlg.m_fs = Fsamp;
	if (dlg.DoModal() == IDOK) {
		if( dlg.m_fc1 >= dlg.m_fs/2 || dlg.m_fc2 >= dlg.m_fs/2 ) {
			CDlgWarnFs dlgW;
			if (dlgW.DoModal() == IDOK) {
			}
		} else if( dlg.m_fc1 >= dlg.m_fc2 ) {
			CDlgWarnFc dlgW;
			if (dlgW.DoModal() == IDOK) {
			}
		} else {
			FC1 = dlg.m_fc1;
			FC2 = dlg.m_fc2;
			Order = dlg.m_order;
			Fsamp = dlg.m_fs;
			freq_range = Fsamp/2;
			FilType = 3;
			design_clicked = TRUE;
		}
		InvalidateRect(NULL, TRUE);
	}
}

void CIirCoeffView::OnPrint(CDC* pDC, CPrintInfo* pInfo) 
{
	CRect rectClient;
	GetClientRect(&rectClient);
	pDC -> SetMapMode(MM_ANISOTROPIC);
	pDC -> SetWindowOrg(0,0);
	pDC -> SetWindowExt(100,50);
	pDC -> SetViewportOrg(0,0);
	pDC -> SetViewportExt(550, 350); // `TCYݒ

	CFont* pfontCurrent = pDC -> GetCurrentFont();
	LOGFONT lfCurrentFont;
	pfontCurrent -> GetObject(sizeof(LOGFONT), &lfCurrentFont);
	CFont fontBig;
	lfCurrentFont.lfHeight = 12; // tHgTCYijݒ
	lfCurrentFont.lfWidth = 6; // tHgTCYijݒ

	fontBig.CreateFontIndirect(&lfCurrentFont);
	CFont* defaultFont = (CFont*)pDC -> SelectObject(&fontBig);

	CView::OnPrint(pDC, pInfo);
}
